"""add retention class to index

Revision ID: cd9b956ca051
Revises: cbd03c81a699
Create Date: 2019-06-02 11:37:05.830850

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
from index_registry.utils.index_field_helpers import properties_from_key
from index_registry.sql.models import Index

revision = 'cd9b956ca051'
down_revision = 'cbd03c81a699'
branch_labels = None
depends_on = None


def upgrade():
    op.add_column('indexes', sa.Column('retention_class', sa.String(), nullable=True))

    conn = op.get_bind()
    for result in conn.execute("SELECT index_path FROM indexes"):
        index_path = result['index_path']

        props = properties_from_key(index_path)

        retention_class = props.get('class')
        if retention_class:
            update_stmt = Index.__table__.update().values({"retention_class": retention_class})\
                .where(Index.index_path == index_path)

            conn.execute(update_stmt)


def downgrade():
    op.drop_column('indexes', 'retention_class')
