from google.cloud import storage


def get_matching_gs_objects(client, bucket, prefix=None, suffix=None):
    kwargs = {'bucket_or_name': bucket}

    if prefix:
        kwargs['prefix'] = prefix

    resp = client.list_blobs(**kwargs)

    for obj in resp:
        key = obj.name
        if not suffix or key.endswith(suffix):
            yield obj


def get_matching_gs_keys(bucket, prefix=None, suffix=None):
    gs_client = storage.Client()

    for obj in get_matching_gs_objects(gs_client, bucket, prefix, suffix):
        yield obj.name, obj.updated


def verify_expired_gcs_path(index_path, gs_client=None):
    if not gs_client:
        gs_client = storage.Client()
    bucket_name, key = index_path.replace("gs://", "").split("/", 1)
    bucket = gs_client.bucket(bucket_name)
    return storage.Blob(bucket=bucket, name=key+".trigger").exists(gs_client)
