import os
import logging
from pscr_common.metrics import PrometheusRegistry

from pscr_common.metrics import get_reporter
from pscr_common.metadata import MetadataProvider

_logger = logging.getLogger(__name__)


def start_reporter(metrics_registry: PrometheusRegistry):
    env = os.environ.get("ENV_ID", "unknown")
    env_meta = MetadataProvider().get_metadata()
    metrics_reporter = get_reporter(
        metrics_registry,
        env,
        env_meta.task_id,
        "index_registry",
        env_meta.image.split(":")[-1],
        str(os.getpid()),
        service_name_as_prefix=True,
    )

    if metrics_reporter:
        metrics_reporter.start()
